VERSION 5.00
Begin VB.Form FormMain 
   Caption         =   "Ross Null Finder, Previously by Doug George, re-written in VB by James C Lerch"
   ClientHeight    =   7200
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9120
   Icon            =   "FormMain.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   7200
   ScaleWidth      =   9120
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chk_save_oslo 
      Caption         =   "Save Oslo file"
      Height          =   375
      Left            =   6000
      TabIndex        =   25
      Top             =   600
      Width           =   855
   End
   Begin VB.CheckBox CHk_QtrWave 
      Caption         =   "Include Lens - Mirror spacing error (IE how good is your tape measure)"
      Height          =   375
      Left            =   6000
      TabIndex        =   24
      Top             =   120
      Width           =   2895
   End
   Begin VB.Frame Units 
      Caption         =   "Units"
      Height          =   615
      Left            =   0
      TabIndex        =   20
      Top             =   0
      Width           =   2175
      Begin VB.OptionButton inches 
         Caption         =   "mm"
         Height          =   195
         Index           =   1
         Left            =   1200
         TabIndex        =   22
         Top             =   240
         Value           =   -1  'True
         Width           =   615
      End
      Begin VB.OptionButton inches 
         Caption         =   "Inch"
         Height          =   195
         Index           =   0
         Left            =   240
         TabIndex        =   21
         Top             =   240
         Width           =   615
      End
   End
   Begin VB.CommandButton FindIt 
      BackColor       =   &H0080FF80&
      Caption         =   "Find Null Variables"
      Height          =   495
      Left            =   6960
      Style           =   1  'Graphical
      TabIndex        =   18
      Top             =   600
      Width           =   1935
   End
   Begin VB.Frame RLData 
      Caption         =   "Ross Null Lens Data"
      Height          =   2055
      Left            =   2280
      TabIndex        =   1
      Top             =   0
      Width           =   3495
      Begin VB.CommandButton Calc_RIn 
         Caption         =   "Refractive Index"
         Height          =   255
         Left            =   120
         TabIndex        =   23
         ToolTipText     =   "Press to Calculate from catalog"
         Top             =   1680
         Width           =   1455
      End
      Begin VB.TextBox LindexR 
         Height          =   285
         Left            =   1680
         TabIndex        =   16
         Text            =   "1.51509"
         Top             =   1680
         Width           =   1575
      End
      Begin VB.TextBox LDiam 
         Height          =   285
         Left            =   1680
         TabIndex        =   15
         Text            =   "80"
         Top             =   1320
         Width           =   1575
      End
      Begin VB.TextBox lthck 
         Height          =   285
         Left            =   1680
         TabIndex        =   13
         Text            =   "15"
         Top             =   960
         Width           =   1575
      End
      Begin VB.TextBox lRadM 
         Height          =   285
         Left            =   1680
         TabIndex        =   11
         Text            =   "-206"
         ToolTipText     =   "WIth Mirror on right, Convex is Negative Value, Concave is Positive Value."
         Top             =   600
         Width           =   1575
      End
      Begin VB.TextBox LradI 
         Height          =   285
         Left            =   1680
         TabIndex        =   9
         Text            =   "9e99"
         ToolTipText     =   "WIth Mirror on Right Convex is Positive Value, Concave is Negative Value"
         Top             =   240
         Width           =   1575
      End
      Begin VB.Label Label7 
         Alignment       =   1  'Right Justify
         Caption         =   "Lens Diameter"
         Height          =   255
         Left            =   480
         TabIndex        =   14
         Top             =   1320
         Width           =   1095
      End
      Begin VB.Label Label6 
         Alignment       =   1  'Right Justify
         Caption         =   "Center Thickness"
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   960
         Width           =   1335
      End
      Begin VB.Label Label5 
         Alignment       =   1  'Right Justify
         Caption         =   "Mirror Side RoC"
         Height          =   255
         Left            =   360
         TabIndex        =   10
         Top             =   600
         Width           =   1215
      End
      Begin VB.Label Label4 
         Alignment       =   1  'Right Justify
         Caption         =   "Source side RoC"
         Height          =   255
         Left            =   360
         TabIndex        =   8
         Top             =   240
         Width           =   1215
      End
   End
   Begin VB.Frame MData 
      Caption         =   "Mirror under test details"
      Height          =   1455
      Left            =   0
      TabIndex        =   0
      Top             =   600
      Width           =   2175
      Begin VB.TextBox Mcc 
         Height          =   285
         Left            =   960
         TabIndex        =   7
         Text            =   "-1"
         Top             =   960
         Width           =   1095
      End
      Begin VB.TextBox MRoC 
         Height          =   285
         Left            =   960
         TabIndex        =   5
         Text            =   "2540"
         Top             =   600
         Width           =   1095
      End
      Begin VB.TextBox MDiam 
         Height          =   285
         Left            =   960
         TabIndex        =   2
         Text            =   "317.5"
         Top             =   240
         Width           =   1095
      End
      Begin VB.Label Label3 
         Caption         =   "Conic Constant"
         Height          =   375
         Left            =   120
         TabIndex        =   6
         Top             =   960
         Width           =   975
      End
      Begin VB.Label Label2 
         Caption         =   "Radius of Curvature"
         Height          =   495
         Left            =   120
         TabIndex        =   4
         Top             =   480
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "Diameter"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   240
         Width           =   855
      End
   End
   Begin VB.TextBox TextOut 
      ForeColor       =   &H00000000&
      Height          =   5295
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   17
      Top             =   2160
      Width           =   9135
   End
   Begin VB.Label abrt 
      Alignment       =   2  'Center
      BackColor       =   &H000000FF&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Press Any Key To Abort"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   975
      Left            =   6000
      TabIndex        =   19
      Top             =   1080
      Visible         =   0   'False
      Width           =   2895
   End
End
Attribute VB_Name = "FormMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'{--------------------------------------------------------------
'|
'|   Name:      RossNull
'|
'|   Location:  ROSSNULL.PAS
'|
'|   Purpose:   Calculates setup for Ross Null test
'|              Refernce: Modern Optical Enginneering
'|              by Warren J. Smith
'|
'|   Copyright (c) 1990 by Doug George
'|   This program may be distributed and used freely
'|   provided the copyright notices are not removed.
'|
'--------------------------------------------------------------}
'**************************************************************
'Translated to Visual Basic 6 by James C Lerch

Option Explicit

Const LDelta As Double = 0.0001
Const SAResidual As Double = 0.0001
Const Pi As Double = 3.14159265358979
Const HalfPi As Double = Pi / 2

Dim mSemiDiameter As Double
Dim mRadius As Double
Dim mConicConst As Double
Dim lRadiusI As Double
Dim lRadiusM As Double
Dim lThick As Double
Dim lIndex As Double
Dim GraphicsOn As Boolean
Dim XScale As Double
Dim YScale As Double
Dim Kill_It As Boolean


Private Declare Function ShellExecute Lib _
 "shell32.dll" Alias "ShellExecuteA" _
 (ByVal hwnd As Long, _
 ByVal lpOperation As String, _
 ByVal lpFile As String, _
 ByVal lpParameters As String, _
 ByVal lpDirectory As String, _
 ByVal nShowCmd As Long) As Long





Private Function ArcSin(ByVal x As Double) As Double
'{--------------------------------------------------------------
'|
'|   Name:      ArcSin
'|   Purpose:   Calculate arcsin function
'|
'--------------------------------------------------------------}
If Abs(x) < 1 Then
    ArcSin = Atn(x / (1 - (x) ^ 2) ^ 0.5)
  ElseIf x < 0# Then
    ArcSin = -HalfPi
  Else
    ArcSin = HalfPi
End If
End Function



Private Function Power(ByVal x As Double, ByVal Y As Double) As Double
'{--------------------------------------------------------------
'|
'|   Name:      Power
'|   Purpose:   Raise a variable to a power
'|
'--------------------------------------------------------------}
If x < 0 Then
    Power = -Exp(Y * (Log(-x))) 'tewet
  ElseIf x = 0 Then
    Power = 1
  Else
    Power = Exp(Y * (Log(x)))
End If
End Function

Private Sub AsphericReflectRay(ByRef Q As Double, ByRef U As Double, ByRef Y As Double, ByVal p As Double, ByVal r As Double)
        'var Q : extended;   { Perpendicular distance of ray to vertex of element }
        'var U : extended;   { Angle of input }
        'var Y : extended;   { Height of intersection }
        'p : extended;   { Conic Constant }
        'r : extended ); { Radius of surface }

'{--------------------------------------------------------------
'|
'|   Name:      AsphericReflectRay
'|   Purpose:   Traces the ray through a reflection off a mirror
'|              with ellipsoid, paraboloid, or hyperboloid surface
'|
'|--------------------------------------------------------------}


Dim x As Double
Dim xEst As Double
Dim a2 As Double
Dim a4 As Double
Dim A6 As Double
Dim A8 As Double
Dim G As Double
Dim m As Double
Dim Phi As Double
Dim Xdir As Double
Dim Ydir As Double

r = -r

'{ Calculate constants for this aspheric }
a2 = 1 / (2 * r)
a4 = p / (8 * Power(r, 3))                      '{ 0 for parabola }
A6 = (p) ^ 2 / (16 * Power(r, 5))               '{ 0 for parabola }
A8 = Power(p, 3) / (25.6 * Power(r, 7))         '{ 0 for parabola }

'{ Calculate position of incidence if the mirror was flat }
Y = Q
x = 0

'{ Calculate direction cosines }
Ydir = Sin(U)
Xdir = Cos(U)

Do
    '{ Calculate value of x given this y for an aspheric surface }
    xEst = a2 * (Y) ^ 2 + a4 * Power(Y, 4) + A6 * Power(Y, 6) + A8 * Power(Y, 8)

    '{ Calculate gradient to correct answer }
    m = -Y * (2 * a2 + 4 * a4 * (Y) ^ 2 + 6 * A6 * Power(Y, 4) + 8 * A8 * Power(Y, 6))
    G = (xEst - x) / (Xdir + Ydir * m)

    '{ Estimate new value }
    x = G * Xdir + x
    Y = G * Ydir + Y
    draw_Spin
    DoEvents
Loop While Abs(x - xEst) > 0.0001 And Not Kill_It

'{ We now have x and y coordinates of intercept point with aspheroid }
'{ Calculate angle between normal and x-axis, then calculate new U }
Phi = Atn(-Y / (r - p * x))
U = 2 * Phi - U

Q = Cos(U) * Y

End Sub

Private Function TraceRay(ByRef Q As Double, ByRef U As Double, ByRef Y As Double, ByVal N As Double, ByVal NP As Double, ByVal r As Double)
'    var Q : extended;   { Perpendicular distance of ray to vertex of element }
'    var U : extended;   { Angle of input }
'    var Y : extended;   { Height of intersection }
'        N : extended;   { Refractive index of input media }
'        Np : extended;  { Refractive index of output media }
'        r : extended ); { Radius of surface }

'{--------------------------------------------------------------
'|
'|   Name:      TraceRay
'|   Purpose:   Traces the ray through a surface
'|
'--------------------------------------------------------------}

Dim i As Double
Dim SinI As Double
Dim Ip As Double
Dim Up As Double
Dim G As Double

'{ Meridional Ray Trace Equations }

'{ Calculate angle of incidence }

SinI = (Q / r) - Sin(U)
i = ArcSin(SinI)

Y = Q * (1 + Cos(U + i)) / (Cos(U) + Cos(i))

'{ Law of refraction to calculate outgoing ray angle of incidence }
Ip = ArcSin(N / NP * SinI)

'{ Calculate output angle from geometric additions }
Up = U + i - Ip

'{ Calculate output rayheight using formula which is stable for flat surface }
G = Q / (Cos(U) + Cos(i))
Q = G * (Cos(Up) + Cos(Ip))       '{ Actually Qp }

'{ Copy new Up into U }
U = Up

End Function

Private Function Transfer(ByRef Q As Double, ByVal Up As Double, ByVal t As Double)

'    var Q  : extended;   { Perpendicular distance of output ray to element vertex }
'        Up : extended;   { Angle of output }
'        t  : extended ); { Distance to next surface }
'{--------------------------------------------------------------
'|
'|   Name:      Transfer
'|   Purpose:   Transfers the ray to the next surface
'|
'--------------------------------------------------------------}


'{ Transfer to Next Surface }
Q = Q - t * Sin(Up)

End Function

Private Sub CalculateLi(ByVal Y As Double, ByVal l As Double, ByVal S As Double, ByRef Li As Double, ByRef Y1 As Double, ByRef Y2 As Double)
'        Y  : extended;               { Height of ray at lens' first surface }
'        L  : extended;               { Distance of object from lens }
'        S  : extended;               { Distance to mirror }
'    var Li : extended;               { Distance to image }
'    var Y1 : extended;               { Ray height at lens' second surface }
'    var Y2 : extended );             { Ray height at mirror }

Dim Q As Double
Dim U As Double

'{ Opening: Calculate initial U and Q }
U = Atn(Y / -l)
Q = -l * Sin(U)

'{ Trace through each element }

TraceRay Q, U, Y, 1#, lIndex, lRadiusI

Transfer Q, U, lThick
TraceRay Q, U, Y1, lIndex, 1#, lRadiusM

Transfer Q, U, S
AsphericReflectRay Q, U, Y2, mConicConst, mRadius

Transfer Q, U, -S
TraceRay Q, U, Y, 1#, lIndex, lRadiusM

Transfer Q, U, -lThick
TraceRay Q, U, Y, lIndex, 1#, lRadiusI

'{ Closing: calculate distance }
Li = Q / Sin(U)

End Sub


Private Sub CalculateLo(ByVal Y As Double, ByVal S As Double, ByRef Lo As Double)

       ' Y      : extended;           { Height of ray at lens }
       ' S      : extended;           { Distance from Lens to Mirror }
        'var Lo     : extended );         { Calculated Lo }
'{--------------------------------------------------------------
'|
'|   Name:      CalculateLo
'|   Purpose:   Calculates the required distance from the
'|              object to the lens' first surface
'|
'--------------------------------------------------------------}

Dim Li As Double
Dim Y1 As Double
Dim Y2 As Double

CalculateLi Y, Lo, S, Li, Y1, Y2
Do
    '{ If not close enough, re-iterate }
    If Abs(Lo + Li) >= LDelta Then
        Lo = Lo - (Lo + Li) * 0.3333333333
    End If

    CalculateLi Y, Lo, S, Li, Y1, Y2
    draw_Spin
    DoEvents
Loop While Abs(Lo + Li) > LDelta And Not Kill_It


End Sub

Private Sub CalculateSA(ByVal S As Double, ByVal H As Double, ByRef Lo As Double, ByRef Y As Double, ByRef SA As Double)
'        S  : extended;    { Mirror-lens spacing }
'        H  : extended;    { Mirror semi-diameter }
'    var Lo : extended;    { Initial object distance to update }
'    var Y  : extended;    { Initial lens ray height to update }
'    var SA : extended );  { Minimum Spherical Aberration given S }
'{--------------------------------------------------------------
'|
'|   Name:      CalculateSA
'|   Purpose:   Given mirror-lens spacing, mirror semi-diameter,
'|              initial ray height at lens' first surface, and
'|              an initial object distance spacing, calculates
'|              required object spacing (based on edge ray), new
'|              ray height, and determines the resulting
'|              spherical aberration between edge ray and
'|              centre ray
'|
'--------------------------------------------------------------}


Dim Li10 As Double
Dim Li100  As Double
Dim Y1 As Double
Dim Y2  As Double

'{ Determine object distance (= image distance) for 100% ray }
CalculateLo Y, S, Lo

'{ Adjust Y to keep Y2 close to mirror edge }
CalculateLi Y, Lo, S, Li100, Y1, Y2
Y = Y * H / Y2

'{ Recalculate Lo with new diameter }
CalculateLo Y, S, Lo

'{ SA: Calculate Li at 10% }
CalculateLi Y * 0.1, Lo, S, Li10, Y1, Y2

SA = Li100 - Li10

End Sub

Private Sub Calc_RIn_Click()
'Show Glass catalog and effective refractive index calculator window
RiN.Show vbModal, Me

End Sub

Private Sub CHk_QtrWave_Click()
'Launch Lens-Mirror error setup calculations

If CHk_QtrWave.Value = 0 Then Exit Sub
Err_Explore.Show vbModal, Me
End Sub

Private Sub FindIt_Click()
Static In_Here As Boolean
TextOut.SetFocus

If In_Here Then Exit Sub Else In_Here = True
FormMain.Enabled = False
If inches(0).Value = True Then
    FindIt_Inch
Else
    FindIt_Metric
End If
FormMain.Enabled = True
FindIt.Caption = "Find Null Variables"
abrt.Visible = False
DoEvents
In_Here = False

End Sub
Private Sub FindIt_Inch()

'{--------------------------------------------------------------
'|
'|   Name:      Mainline in Inches
'|   Purpose:   Performs Ross Null setup calculations
'|
'--------------------------------------------------------------}

Dim Lo As Double
Dim Li10 As Double
Dim Li70 As Double
Dim Li100 As Double
Dim S As Double
Dim Y As Double
Dim Y1 As Double
Dim Y2 As Double
Dim SA As Double
Dim Tol As Double
Dim OPD As Double
Dim Ch As String
Dim i As Long
Dim AdjustGain As Double
Dim adjust As Double
Dim lFL As Double
Dim lDiameter As Double
Dim Save_Oslo As Boolean
Dim Oslo_Out As String
Dim Oslo_Name As String
Dim Pause_Display As Long
Dim Filehandle%


Kill_It = False

Save_Oslo = (chk_save_oslo.Value = 1)

TextOut.Text = ""

abrt.Visible = True

On Error GoTo NumbersPls:

TextOut.Text = "Using these Mirror Parameters" & vbCrLf & _
                 vbCrLf & _
                "Diameter =" & vbTab & vbTab & "-> " & MDiam.Text & Chr(34) & vbCrLf
                
mSemiDiameter = CDbl(MDiam.Text) * 0.5

TextOut.Text = TextOut.Text & _
                "Mirror Radius of Curvature =" & vbTab & "-> " & MRoC.Text & Chr(34) & vbCrLf
    mRadius = -Abs(CDbl(MRoC.Text))

If Mcc.Text = 0 Then
    TextOut.Text = TextOut.Text & _
                "Mirror Conic Constant = " & vbTab & "-> 0 (Sphere)" & vbCrLf
ElseIf Mcc.Text < 0 And Mcc.Text > -1 Then
    TextOut.Text = TextOut.Text & _
                "Mirror Conic Constant = " & vbTab & "-> " & Mcc.Text & " (Ellipse)" & vbCrLf
ElseIf Mcc.Text = -1 Then
    TextOut.Text = TextOut.Text & _
            "Mirror Conic Constant = " & vbTab & "-> -1 (Parabola)" & vbCrLf
ElseIf Mcc.Text < -1 Then
    TextOut.Text = TextOut.Text & _
            "Mirror Conic Constant = " & vbTab & "-> " & Mcc.Text & " (Hyperbola)" & vbCrLf
ElseIf Mcc.Text > 0 Then
    TextOut.Text = TextOut.Text & _
            "Mirror Conic Constant = " & vbTab & "-> " & Mcc.Text & " (Oblate Spheroid)" & vbCrLf
End If
mConicConst = 1 + CDbl(Mcc.Text)

TextOut.Text = TextOut.Text & vbCrLf
    
TextOut.Text = TextOut.Text & "Lens Parameters" & vbCrLf & vbCrLf & _
                              "Sign Convention: With mirror on right, ) = -ve, ( = +ve" & vbCrLf & _
                              "Image Side Radius = " & vbTab & "-> " & Round(CDbl(LradI.Text), 6) & Chr(34)
                              If LradI.Text > 0 Then
                                If LradI.Text > 10000 Then
                                    TextOut.Text = TextOut.Text & " Flat" & vbCrLf
                                Else
                                    TextOut.Text = TextOut.Text & " Convex" & vbCrLf
                                End If
                              Else
                                If LradI.Text < 10000 Then
                                    TextOut.Text = TextOut.Text & " Flat" & vbCrLf
                                Else
                                    TextOut.Text = TextOut.Text & " Concave" & vbCrLf
                                End If
                              End If
                              
lRadiusI = CDbl(LradI.Text)
    

TextOut.Text = TextOut.Text & "Mirror Side Radius =" & vbTab & vbTab & "-> " & Round(lRadM.Text, 6) & Chr(34)
                              If lRadM.Text > 0 Then
                                If lRadM.Text > 10000 Then
                                    TextOut.Text = TextOut.Text & " Flat" & vbCrLf
                                Else
                                    TextOut.Text = TextOut.Text & " Concave" & vbCrLf
                                End If
                              Else
                                If lRadM.Text > 10000 Then
                                    TextOut.Text = TextOut.Text & " Flat" & vbCrLf
                                Else
                                    TextOut.Text = TextOut.Text & " Convex" & vbCrLf
                                End If
                              End If

lRadiusM = CDbl(lRadM.Text)

TextOut.Text = TextOut.Text & "Thickness =" & vbTab & vbTab & "-> " & Round(lthck.Text, 6) & Chr(34) & vbCrLf

lThick = CDbl(lthck.Text)

TextOut.Text = TextOut.Text & "Diameter =" & vbTab & vbTab & "-> " & Round(LDiam.Text, 6) & Chr(34) & vbCrLf

lDiameter = CDbl(LDiam.Text)

TextOut.Text = TextOut.Text & "Refractive Index =" & vbTab & vbTab & "-> " & LindexR.Text & " " & " = " & GlassName & " @ " & WaveLength * 1000 & "nm" & vbCrLf

lIndex = CDbl(LindexR.Text)

'    { Calculate Lens Focal Length }
lFL = 1 / ((lIndex - 1) * ((-1 / lRadiusM) + (1 / lRadiusI)))
    
TextOut.Text = TextOut.Text & "Lens Focal Length = " & vbTab & "-> " & Round(lFL, 6) & Chr(34) & vbCrLf & vbCrLf

    S = 0

    '{ Guess initial Lo based on 1/2 lens focal length }
    Lo = lFL * 0.5

    '{ Guess S at mirror radius minus lens focal length }
    S = -mRadius - lFL

    '{ Guess Y from simple geometry }
    Y = (mRadius + S) / mRadius * mSemiDiameter

    '{ Pick useable adjustment gain factor using mirror and lens F/ratio }
    AdjustGain = Power(-mRadius / mSemiDiameter / 4, 1.5) * lFL / lDiameter

    Dim TempText As String
    TempText = TextOut.Text
    
    Pause_Display = 0 'pause delay before refreashing screen text while searching data
    
    Do
        CalculateSA S, mSemiDiameter, Lo, Y, SA
        
        Pause_Display = Pause_Display + 1
        If Pause_Display > 10 Then
            TextOut.Text = TempText & "Object-Lens =" & Lo & " " & vbCrLf & _
                    "Lens-Mirror = " & S & " " & vbCrLf & _
                    "Marginal SA = " & SA & " " & vbCrLf
            
            Pause_Display = 0
        End If
            
        If (Abs(SA) > SAResidual) Then
            
            adjust = SA * AdjustGain
            If adjust > 1 Then
                adjust = 1
            Else
                If adjust < -1 Then
                    adjust = -1
                End If
            End If
            S = S + adjust
        End If
        DoEvents
        draw_Spin
    Loop While (Abs(SA) > SAResidual) And Not Kill_It

    '{ Calculate a few output parameters }
    CalculateLi Y * 0.1, Lo, S, Li10, Y1, Y2    '{ To get Li10 }
    CalculateLi Y * 0.7, Lo, S, Li70, Y1, Y2    '{ To get Li70 }
    CalculateLi Y, Lo, S, Li100, Y1, Y2         '{ To get Y1 }
    
    Tol = 0.008 / 25.4 * ((Lo / (2 * Y)) ^ 2)

    OPD = Abs(Li70 - Li10)
    If OPD < Abs(Li100 - Li10) Then OPD = Abs(Li100 - Li10)
        
    If OPD < Abs(Li100 - Li70) Then OPD = Abs(Li100 - Li70)
    OPD = OPD / (4 * Tol)


TextOut.Text = TempText & _
    "Results: " & vbCrLf & _
    "Object to Lens Distance         " & vbTab & vbTab & "=" & vbTab & Round(Lo, 4) & Chr(34) & vbCrLf & _
    "Lens to Mirror Distance         " & vbTab & vbTab & "=" & vbTab & Round(S, 4) & Chr(34) & vbCrLf & _
    "Working Diameter of Lens        " & vbTab & "=" & vbTab & Round(Y1 * 2, 4) & Chr(34) & vbCrLf & _
    "70% Zone Spherical Aberration   " & vbTab & "=" & vbTab & Round(Li70 - Li10, 4) & Chr(34) & vbCrLf & _
    "Marginal Spherical Aberration   " & vbTab & "=" & vbTab & Round(Li100 - Li10, 4) & Chr(34) & vbCrLf & _
    "Quarter-wave Tolerence          " & vbTab & "=" & vbTab & Round(Tol, 4) & Chr(34) & vbCrLf & _
    "Maximum Optical Path Difference " & vbTab & "=" & vbTab & Round(OPD, 4) & " Waves"


'Saves OSLO.len file, if so selected by user
If Save_Oslo And GlassName <> "" Then
    
    If Right(App.Path, 1) <> "\" Then
        Oslo_Name = App.Path & "\" & Round(MDiam.Text, 0) & "inch" & "_F-" & Round((MRoC.Text / MDiam.Text) / 2, 1) & "_created_" & Replace(Date, "/", "_", , , vbTextCompare) & "@" & Replace(Time, ":", "_", , , vbTextCompare) & ".len"
    Else
        Oslo_Name = App.Path & Round(MDiam.Text, 0) & "inch" & "_F-" & Round((MRoC.Text / MDiam.Text) / 2, 1) & "_created_" & Replace(Date, "/", "_", , , vbTextCompare) & "@" & Replace(Time, ":", "_", , , vbTextCompare) & ".len"
    End If
    Oslo_Out = "// OSLO 6.2 50002     0     0" & vbCrLf & _
               "LEN NEW " & Chr(34) & "Ross_Null_Best" & Chr(34) & " 0 6 " & vbCrLf & _
               "EBR  " & Round((Y1), 6) & vbCrLf & _
               "ANG  0.0000001" & vbCrLf & _
               "DES  " & Chr(34) & "OSLO" & Chr(34) & vbCrLf & _
               "UNI 25.4" & vbCrLf & _
               "// SRF 0" & vbCrLf & _
               "AIR" & vbCrLf & _
               "TH " & Round(Lo, 9) & vbCrLf & _
               "AP 0.000248528801" & vbCrLf & _
               "NXT  // SRF 1" & vbCrLf & _
               "GLA " & GlassName & vbCrLf & _
               "RD " & LradI.Text & vbCrLf & _
               "TH " & lthck.Text & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 2" & vbCrLf & _
               "AIR" & vbCrLf & _
               "RD " & lRadM.Text & vbCrLf & _
               "TH " & Round(S, 6) & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 3" & vbCrLf & _
               "RFH" & vbCrLf & _
               "RD " & CDbl(MRoC.Text) * -1 & vbCrLf & _
               "PK THM  -1 0.0" & vbCrLf & _
               "AP " & mSemiDiameter & vbCrLf
    Oslo_Out = Oslo_Out & _
               "AST" & vbCrLf & _
               "CC " & Mcc.Text & vbCrLf & _
               "NXT  // SRF 4" & vbCrLf & _
               "GLA " & GlassName & vbCrLf & _
               "PK CV   -2 0.0" & vbCrLf & _
               "PK THM  -3 0.0" & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 5" & vbCrLf & _
               "AIR" & vbCrLf & _
               "PK CV   -4 0.0" & vbCrLf & _
               "PK THM  -5 0.0" & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 6" & vbCrLf & _
               "AIR" & vbCrLf & _
               "CBK 1" & vbCrLf & _
               "WV " & WaveLength & " " & WaveLength & " " & WaveLength & " " & vbCrLf & _
               "WW 1.0 1.0 1.0" & vbCrLf & _
               "END  6" & vbCrLf & _
               "DLRS 3"
    
    Filehandle% = FreeFile
    Open (Oslo_Name) For Output As #Filehandle%
    Print #Filehandle%, Oslo_Out
    Close #Filehandle%
    
    Dim ttext As String
    
    If (check_file_ass(ttext)) Then
        If ttext <> "" And (vbYes = MsgBox("Launch Oslo File Now?", vbYesNo)) Then
            ShellExecute Me.hwnd, vbNullString, Oslo_Name, vbNullString, App.Path, 1
        End If
    End If
    
Else
    If Save_Oslo <> False Then MsgBox "Alas, you must visit the Refractive index menu above." & vbCrLf & "Oslo needs to know Glass Type used, not just refractive index, sorry.", vbOKOnly And vbCritical
    Save_Oslo = False
End If


If CHk_QtrWave.Value = 0 Then
    FindIt.Caption = "Find Null Variables"
    abrt.Visible = False
    Exit Sub
End If

'********** find + 1/4 wave OPD If selected by user
 
Dim SPrime As Double
Dim SPlus As Double
Dim SMin As Double

SPrime = S

If Err_Iterate Then
    TempText = TextOut.Text & vbCrLf & vbCrLf & "*** Finding 1/" & Round((1 / ErrMargin), 2) & " wave OPD values for positive error in mirror - lens spacing " & vbCrLf & vbCrLf
Else
    TempText = TextOut.Text & vbCrLf & vbCrLf
End If
    
    Do
        
        Lo = lFL * 0.5
        If Err_Iterate Then
            S = S + 0.001
        Else
            S = S + ErrMargin
        End If
        
        '{ Guess Y from simple geometry }
        Y = (mRadius + S) / mRadius * mSemiDiameter
        
        CalculateSA S, mSemiDiameter, Lo, Y, SA

        Pause_Display = Pause_Display + 1
        
        If Pause_Display > 10 Then
            TextOut.Text = TempText & "Object-Lens =" & Lo & " " & vbCrLf & _
                    "Lens-Mirror = " & S & " " & vbCrLf & _
                    "Marginal SA = " & SA & " " & vbCrLf
            
            Pause_Display = 0
        End If
            
        '{ Calculate a few output parameters }
        CalculateLi Y * 0.1, Lo, S, Li10, Y1, Y2    '{ To get Li10 }
        CalculateLi Y * 0.7, Lo, S, Li70, Y1, Y2    '{ To get Li70 }
        CalculateLi Y, Lo, S, Li100, Y1, Y2         '{ To get Y1 }
    
        Tol = 0.008 / 25.4 * ((Lo / (2 * Y)) ^ 2)

        OPD = Abs(Li70 - Li10)
        If OPD < Abs(Li100 - Li10) Then OPD = Abs(Li100 - Li10)
        
        If OPD < Abs(Li100 - Li70) Then OPD = Abs(Li100 - Li70)
        OPD = OPD / (4 * Tol)
        
        draw_Spin
        DoEvents
    Loop While Abs(OPD) <= ErrMargin And Not Kill_It And Err_Iterate
    
        
SPlus = Round(S - SPrime, 3)

TextOut.Text = TempText & _
    "Results for lens mirror spacing error of +" & SPlus & Chr(34) & vbCrLf & _
    "Object to Lens Distance         " & vbTab & vbTab & "=" & vbTab & Round(Lo, 4) & Chr(34) & vbCrLf & _
    "Lens to Mirror Distance         " & vbTab & vbTab & "=" & vbTab & Round(S, 4) & Chr(34) & vbCrLf & _
    "Working Diameter of Lens        " & vbTab & "=" & vbTab & Round(Y1 * 2, 4) & Chr(34) & vbCrLf & _
    "70% Zone Spherical Aberration   " & vbTab & "=" & vbTab & Round(Li70 - Li10, 4) & Chr(34) & vbCrLf & _
    "Marginal Spherical Aberration   " & vbTab & "=" & vbTab & Round(Li100 - Li10, 4) & Chr(34) & vbCrLf & _
    "Quarter-wave Tolerence          " & vbTab & "=" & vbTab & Round(Tol, 4) & Chr(34) & vbCrLf & _
    "Maximum Optical Path Difference " & vbTab & "=" & vbTab & Round(OPD, 4) & " Waves"

    
If Save_Oslo And GlassName <> "" Then
    
    If Right(App.Path, 1) <> "\" Then
        Oslo_Name = App.Path & "\" & Round(MDiam.Text, 0) & "inch" & "_F-" & Round((MRoC.Text / MDiam.Text) / 2, 1) & "_created_" & Replace(Date, "/", "_", , , vbTextCompare) & "@" & Replace(Time, ":", "_", , , vbTextCompare) & ".len"
    Else
        Oslo_Name = App.Path & Round(MDiam.Text, 0) & "inch" & "_F-" & Round((MRoC.Text / MDiam.Text) / 2, 1) & "_created_" & Replace(Date, "/", "_", , , vbTextCompare) & "@" & Replace(Time, ":", "_", , , vbTextCompare) & ".len"
    End If
    Oslo_Out = "// OSLO 6.2 50002     0     0" & vbCrLf & _
               "LEN NEW " & Chr(34) & "Ross_Null_Positive_Spacing_Error" & Chr(34) & " 0 6 " & vbCrLf & _
               "EBR  " & Round((Y1), 6) & vbCrLf & _
               "ANG  0.0000001" & vbCrLf & _
               "DES  " & Chr(34) & "OSLO" & Chr(34) & vbCrLf & _
               "UNI 25.4" & vbCrLf & _
               "// SRF 0" & vbCrLf & _
               "AIR" & vbCrLf & _
               "TH " & Round(Lo, 9) & vbCrLf & _
               "AP 0.000248528801" & vbCrLf & _
               "NXT  // SRF 1" & vbCrLf & _
               "GLA " & GlassName & vbCrLf & _
               "RD " & LradI.Text & vbCrLf & _
               "TH " & lthck.Text & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 2" & vbCrLf & _
               "AIR" & vbCrLf & _
               "RD " & lRadM.Text & vbCrLf & _
               "TH " & Round(S, 6) & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 3" & vbCrLf & _
               "RFH" & vbCrLf & _
               "RD " & CDbl(MRoC.Text) * -1 & vbCrLf & _
               "PK THM  -1 0.0" & vbCrLf & _
               "AP " & mSemiDiameter & vbCrLf
    Oslo_Out = Oslo_Out & _
               "AST" & vbCrLf & _
               "CC " & Mcc.Text & vbCrLf & _
               "NXT  // SRF 4" & vbCrLf & _
               "GLA " & GlassName & vbCrLf & _
               "PK CV   -2 0.0" & vbCrLf & _
               "PK THM  -3 0.0" & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 5" & vbCrLf & _
               "AIR" & vbCrLf & _
               "PK CV   -4 0.0" & vbCrLf & _
               "PK THM  -5 0.0" & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 6" & vbCrLf & _
               "AIR" & vbCrLf & _
               "CBK 1" & vbCrLf & _
               "WV " & WaveLength & " " & WaveLength & " " & WaveLength & " " & vbCrLf & _
               "WW 1.0 1.0 1.0" & vbCrLf & _
               "END  6" & vbCrLf & _
               "DLRS 3"
    
    Filehandle% = FreeFile
    Open (Oslo_Name) For Output As #Filehandle%
    Print #Filehandle%, Oslo_Out
    Close #Filehandle%
    
    If (check_file_ass(ttext)) Then
        If ttext <> "" And (vbYes = MsgBox("Launch Oslo File Now?", vbYesNo)) Then
            ShellExecute Me.hwnd, vbNullString, Oslo_Name, vbNullString, App.Path, 1
        End If
    End If
    
Else
    If Save_Oslo <> False Then MsgBox "Alas, you must visit the Refractive index menu above." & vbCrLf & "Oslo needs to know Glass Type used, not just refractive index, sorry.", vbOKOnly And vbCritical
    Save_Oslo = False
End If


'********* Find Negative error margin *********

If Err_Iterate Then
    TempText = TextOut.Text & vbCrLf & vbCrLf & "*** Finding 1/" & Round((1 / ErrMargin), 2) & " wave OPD values for positive error in mirror - lens spacing " & vbCrLf & vbCrLf
Else
    TempText = TextOut.Text & vbCrLf & vbCrLf
End If

S = SPrime
    Do
        
        Lo = lFL * 0.5
        If Err_Iterate Then
            S = S - 0.001
        Else
            S = S - ErrMargin
        End If
        '{ Guess Y from simple geometry }
        Y = (mRadius + S) / mRadius * mSemiDiameter
        
        CalculateSA S, mSemiDiameter, Lo, Y, SA

        Pause_Display = Pause_Display + 1
        If Pause_Display > 10 Then
            TextOut.Text = TempText & "Object-Lens =" & Lo & " " & vbCrLf & _
                    "Lens-Mirror = " & S & " " & vbCrLf & _
                    "Marginal SA = " & SA & " " & vbCrLf
            
            Pause_Display = 0
        End If
        
        '{ Calculate a few output parameters }
        CalculateLi Y * 0.1, Lo, S, Li10, Y1, Y2    '{ To get Li10 }
        CalculateLi Y * 0.7, Lo, S, Li70, Y1, Y2    '{ To get Li70 }
        CalculateLi Y, Lo, S, Li100, Y1, Y2         '{ To get Y1 }
    
        Tol = 0.008 / 25.4 * ((Lo / (2 * Y)) ^ 2)

        OPD = Abs(Li70 - Li10)
        If OPD < Abs(Li100 - Li10) Then OPD = Abs(Li100 - Li10)
        
        If OPD < Abs(Li100 - Li70) Then OPD = Abs(Li100 - Li70)
        OPD = OPD / (4 * Tol)
        
        draw_Spin
        DoEvents
    Loop While Abs(OPD) <= ErrMargin And Not Kill_It And Err_Iterate
    
        
SMin = Round(S - SPrime, 3)
TextOut.Text = TempText & _
    "Results for lens mirror spacing error of " & SMin & Chr(34) & vbCrLf & _
    "Object to Lens Distance         " & vbTab & vbTab & "=" & vbTab & Round(Lo, 4) & Chr(34) & vbCrLf & _
    "Lens to Mirror Distance         " & vbTab & vbTab & "=" & vbTab & Round(S, 4) & Chr(34) & vbCrLf & _
    "Working Diameter of Lens        " & vbTab & "=" & vbTab & Round(Y1 * 2, 4) & Chr(34) & vbCrLf & _
    "70% Zone Spherical Aberration   " & vbTab & "=" & vbTab & Round(Li70 - Li10, 4) & Chr(34) & vbCrLf & _
    "Marginal Spherical Aberration   " & vbTab & "=" & vbTab & Round(Li100 - Li10, 4) & Chr(34) & vbCrLf & _
    "Quarter-wave Tolerence          " & vbTab & "=" & vbTab & Round(Tol, 4) & Chr(34) & vbCrLf & _
    "Maximum Optical Path Difference " & vbTab & "=" & vbTab & Round(OPD, 4) & " Waves"


If Save_Oslo And GlassName <> "" Then
    
    If Right(App.Path, 1) <> "\" Then
        Oslo_Name = App.Path & "\" & Round(MDiam.Text, 0) & "inch" & "_F-" & Round((MRoC.Text / MDiam.Text) / 2, 1) & "_created_" & Replace(Date, "/", "_", , , vbTextCompare) & "@" & Replace(Time, ":", "_", , , vbTextCompare) & ".len"
    Else
        Oslo_Name = App.Path & Round(MDiam.Text, 0) & "inch" & "_F-" & Round((MRoC.Text / MDiam.Text) / 2, 1) & "_created_" & Replace(Date, "/", "_", , , vbTextCompare) & "@" & Replace(Time, ":", "_", , , vbTextCompare) & ".len"
    End If
    Oslo_Out = "// OSLO 6.2 50002     0     0" & vbCrLf & _
               "LEN NEW " & Chr(34) & "Ross_Null_Negeative_Spacing_Error" & Chr(34) & " 0 6 " & vbCrLf & _
               "EBR  " & Round((Y1), 6) & vbCrLf & _
               "ANG  0.0000001" & vbCrLf & _
               "DES  " & Chr(34) & "OSLO" & Chr(34) & vbCrLf & _
               "UNI 25.4" & vbCrLf & _
               "// SRF 0" & vbCrLf & _
               "AIR" & vbCrLf & _
               "TH " & Round(Lo, 9) & vbCrLf & _
               "AP 0.000248528801" & vbCrLf & _
               "NXT  // SRF 1" & vbCrLf & _
               "GLA " & GlassName & vbCrLf & _
               "RD " & LradI.Text & vbCrLf & _
               "TH " & lthck.Text & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 2" & vbCrLf & _
               "AIR" & vbCrLf & _
               "RD " & lRadM.Text & vbCrLf & _
               "TH " & Round(S, 6) & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 3" & vbCrLf & _
               "RFH" & vbCrLf & _
               "RD " & CDbl(MRoC.Text) * -1 & vbCrLf & _
               "PK THM  -1 0.0" & vbCrLf & _
               "AP " & mSemiDiameter & vbCrLf
    Oslo_Out = Oslo_Out & _
               "AST" & vbCrLf & _
               "CC " & Mcc.Text & vbCrLf & _
               "NXT  // SRF 4" & vbCrLf & _
               "GLA " & GlassName & vbCrLf & _
               "PK CV   -2 0.0" & vbCrLf & _
               "PK THM  -3 0.0" & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 5" & vbCrLf & _
               "AIR" & vbCrLf & _
               "PK CV   -4 0.0" & vbCrLf & _
               "PK THM  -5 0.0" & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 6" & vbCrLf & _
               "AIR" & vbCrLf & _
               "CBK 1" & vbCrLf & _
               "WV " & WaveLength & " " & WaveLength & " " & WaveLength & " " & vbCrLf & _
               "WW 1.0 1.0 1.0" & vbCrLf & _
               "END  6" & vbCrLf & _
               "DLRS 3"
    
    Filehandle% = FreeFile
    Open (Oslo_Name) For Output As #Filehandle%
    Print #Filehandle%, Oslo_Out
    Close #Filehandle%
    
    If (check_file_ass(ttext)) Then
        If ttext <> "" And (vbYes = MsgBox("Launch Oslo File Now?", vbYesNo)) Then
            ShellExecute Me.hwnd, vbNullString, Oslo_Name, vbNullString, App.Path, 1
        End If
    End If
    
Else
    If Save_Oslo <> False Then MsgBox "Alas, you must visit the Refractive index menu above." & vbCrLf & "Oslo needs to know Glass Type used, not just refractive index, sorry.", vbOKOnly And vbCritical
    Save_Oslo = False
End If

FindIt.Caption = "Find Null Variables"
abrt.Visible = False

Exit Sub



NumbersPls:
MsgBox "Please check your data entries, seems there is a problem reading one of your entries as a Numerical Value" & vbCrLf & _
                "**OR**" & vbCrLf & _
                "The program converged to an infinity (IE division by zero)", vbOKOnly And vbCritical, "Hmmm, how did that happen?"
    
End Sub

Private Sub FindIt_Metric()

'{--------------------------------------------------------------
'|
'|   Name:      Mainline in Inches
'|   Purpose:   Performs Ross Null setup calculations
'|
'--------------------------------------------------------------}

Dim Lo As Double
Dim Li10 As Double
Dim Li70 As Double
Dim Li100 As Double
Dim S As Double
Dim Y As Double
Dim Y1 As Double
Dim Y2 As Double
Dim SA As Double
Dim Tol As Double
Dim OPD As Double
Dim Ch As String
Dim i As Long
Dim AdjustGain As Double
Dim adjust As Double
Dim lFL As Double
Dim lDiameter As Double
Dim Save_Oslo As Boolean
Dim Oslo_Out As String
Dim Oslo_Name As String
Dim Pause_Display As Long
Dim Filehandle%

Kill_It = False

Save_Oslo = (chk_save_oslo.Value = 1)

TextOut.Text = ""

abrt.Visible = True

On Error GoTo NumbersPls:

TextOut.Text = "Using these Mirror Parameters" & vbCrLf & _
                vbCrLf & _
                "Diameter =" & vbTab & vbTab & "-> " & MDiam.Text & "mm" & vbCrLf

mSemiDiameter = CDbl(MDiam.Text / 25.4) * 0.5

TextOut.Text = TextOut.Text & _
                "Mirror Radius of Curvature =" & vbTab & "-> " & MRoC.Text & " mm" & vbCrLf
mRadius = -Abs(CDbl(MRoC.Text / 25.4))

If Mcc.Text = 0 Then
    TextOut.Text = TextOut.Text & _
                "Mirror Conic Constant = " & vbTab & "-> 0 (Sphere)" & vbCrLf
ElseIf Mcc.Text < 0 And Mcc.Text > -1 Then
    TextOut.Text = TextOut.Text & _
                "Mirror Conic Constant = " & vbTab & "-> " & Mcc.Text & " (Ellipse)" & vbCrLf
ElseIf Mcc.Text = -1 Then
    TextOut.Text = TextOut.Text & _
            "Mirror Conic Constant = " & vbTab & "-> -1 (Parabola)" & vbCrLf
ElseIf Mcc.Text < -1 Then
    TextOut.Text = TextOut.Text & _
            "Mirror Conic Constant = " & vbTab & "-> " & Mcc.Text & " (Hyperbola)" & vbCrLf
ElseIf Mcc.Text > 0 Then
    TextOut.Text = TextOut.Text & _
            "Mirror Conic Constant = " & vbTab & "-> " & Mcc.Text & " (Oblate Spheroid" & vbCrLf
End If
mConicConst = 1 + CDbl(Mcc.Text)

TextOut.Text = TextOut.Text & vbCrLf
    
TextOut.Text = TextOut.Text & "Lens Parameters" & vbCrLf & vbCrLf & _
                              "Sign Convention: With mirror on right, ) = -ve, ( = +ve" & vbCrLf & _
                              "Image Side Radius = " & vbTab & "-> " & LradI.Text & " mm"
                              If LradI.Text > 0 Then
                                If LradI.Text > 254000 Then
                                    TextOut.Text = TextOut.Text & " Flat" & vbCrLf
                                Else
                                    TextOut.Text = TextOut.Text & " Convex" & vbCrLf
                                End If
                              Else
                                If LradI.Text < 254000 Then
                                    TextOut.Text = TextOut.Text & " Flat" & vbCrLf
                                Else
                                    TextOut.Text = TextOut.Text & " Concave" & vbCrLf
                                End If
                              End If
                              
lRadiusI = CDbl(LradI.Text / 25.4)
    

TextOut.Text = TextOut.Text & "Mirror Side Radius =" & vbTab & vbTab & "-> " & lRadM.Text & " mm"
                              If lRadM.Text > 0 Then
                                If lRadM.Text > 10000 Then
                                    TextOut.Text = TextOut.Text & " Flat" & vbCrLf
                                Else
                                    TextOut.Text = TextOut.Text & " Concave" & vbCrLf
                                End If
                              Else
                                If lRadM.Text > 10000 Then
                                    TextOut.Text = TextOut.Text & " Flat" & vbCrLf
                                Else
                                    TextOut.Text = TextOut.Text & " Convex" & vbCrLf
                                End If
                              End If

lRadiusM = CDbl(lRadM.Text / 25.4)

TextOut.Text = TextOut.Text & "Thickness =" & vbTab & vbTab & "-> " & lthck.Text & " mm" & vbCrLf

lThick = CDbl(lthck.Text / 25.4)

TextOut.Text = TextOut.Text & "Diameter =" & vbTab & vbTab & "-> " & LDiam.Text & " mm" & vbCrLf

lDiameter = CDbl(LDiam.Text / 25.4)

TextOut.Text = TextOut.Text & "Refractive Index =" & vbTab & vbTab & "-> " & LindexR.Text & " " & " = " & GlassName & " @ " & WaveLength * 1000 & "nm" & vbCrLf

lIndex = CDbl(LindexR.Text)

'    { Calculate Lens Focal Length }
lFL = 1 / ((lIndex - 1) * ((-1 / lRadiusM) + (1 / lRadiusI)))

TextOut.Text = TextOut.Text & "Lens Focal Length = " & vbTab & "-> " & Round(lFL * 25.4, 3) & " mm" & vbCrLf & vbCrLf
    S = 0
    
    '{ Guess initial Lo based on 1/2 lens focal length }
    Lo = lFL * 0.5

    '{ Guess S at mirror radius minus lens focal length }
    S = -mRadius - lFL

    '{ Guess Y from simple geometry }
    Y = (mRadius + S) / mRadius * mSemiDiameter

    '{ Pick useable adjustment gain factor using mirror and lens F/ratio }
    AdjustGain = Power(-mRadius / mSemiDiameter / 4, 1.5) * lFL / lDiameter

    Dim TempText As String
    TempText = TextOut.Text
    
    Do
        CalculateSA S, mSemiDiameter, Lo, Y, SA

        Pause_Display = Pause_Display + 1
        If Pause_Display > 10 Then
            TextOut.Text = TempText & "Object-Lens =" & Lo * 25.4 & " " & vbCrLf & _
                                      "Lens-Mirror = " & S * 25.4 & " " & vbCrLf & _
                                       "Marginal SA = " & SA * 25.4 & " " & vbCrLf
            Pause_Display = 0
        End If
          
        If (Abs(SA) > SAResidual) Then
            
            adjust = SA * AdjustGain
            If adjust > 1 Then
                adjust = 1
            Else
                If adjust < -1 Then
                    adjust = -1
                End If
            End If
            S = S + adjust
        End If
        DoEvents
        draw_Spin
    Loop While (Abs(SA) > SAResidual) And Not Kill_It

    '{ Calculate a few output parameters }
    CalculateLi Y * 0.1, Lo, S, Li10, Y1, Y2    '{ To get Li10 }
    CalculateLi Y * 0.7, Lo, S, Li70, Y1, Y2    '{ To get Li70 }
    CalculateLi Y, Lo, S, Li100, Y1, Y2         '{ To get Y1 }
    
    Tol = 0.008 / 25.4 * ((Lo / (2 * Y)) ^ 2)

    OPD = Abs(Li70 - Li10)
    If OPD < Abs(Li100 - Li10) Then OPD = Abs(Li100 - Li10)
        
    If OPD < Abs(Li100 - Li70) Then OPD = Abs(Li100 - Li70)
    OPD = OPD / (4 * Tol)


TextOut.Text = TempText & _
    "Results: " & vbCrLf & _
    "Object to Lens Distance         " & vbTab & vbTab & "=" & vbTab & Round(Lo * 25.4, 3) & " mm" & vbCrLf & _
    "Lens to Mirror Distance         " & vbTab & vbTab & "=" & vbTab & Round(S * 25.4, 3) & " mm" & vbCrLf & _
    "Working Diameter of Lens        " & vbTab & "=" & vbTab & Round((Y1 * 2) * 25.4, 3) & " mm" & vbCrLf & _
    "70% Zone Spherical Aberration   " & vbTab & "=" & vbTab & Round((Li70 - Li10) * 25.4, 3) & " mm" & vbCrLf & _
    "Marginal Spherical Aberration   " & vbTab & "=" & vbTab & Round((Li100 - Li10) * 25.4, 3) & " mm" & vbCrLf & _
    "Quarter-wave Tolerence          " & vbTab & "=" & vbTab & Round(Tol * 25.4, 3) & " mm" & vbCrLf & _
    "Maximum Optical Path Difference " & vbTab & "=" & vbTab & Round(OPD, 3) & " Waves"

If Save_Oslo And GlassName <> "" Then
    
    If Right(App.Path, 1) <> "\" Then
        Oslo_Name = App.Path & "\" & Round(MDiam.Text, 0) & " mm" & "_F-" & Round((MRoC.Text / MDiam.Text) / 2, 1) & "_created_" & Replace(Date, "/", "_", , , vbTextCompare) & "@" & Replace(Time, ":", "_", , , vbTextCompare) & ".len"
    Else
        Oslo_Name = App.Path & Round(MDiam.Text, 0) & " mm" & "_F-" & Round((MRoC.Text / MDiam.Text) / 2, 1) & "_created_" & Replace(Date, "/", "_", , , vbTextCompare) & "@" & Replace(Time, ":", "_", , , vbTextCompare) & ".len"
    End If
    Oslo_Out = "// OSLO 6.2 50002     0     0" & vbCrLf & _
               "LEN NEW " & Chr(34) & "Ross_Null_Best" & Chr(34) & " 0 6 " & vbCrLf & _
               "EBR  " & Round((Y1 * 25.4), 6) & vbCrLf & _
               "ANG  0.0000001" & vbCrLf & _
               "DES  " & Chr(34) & "OSLO" & Chr(34) & vbCrLf & _
               "UNI 1.0" & vbCrLf & _
               "// SRF 0" & vbCrLf & _
               "AIR" & vbCrLf & _
               "TH " & Round(Lo * 25.4, 9) & vbCrLf & _
               "AP 0.000248528801" & vbCrLf & _
               "NXT  // SRF 1" & vbCrLf & _
               "GLA " & GlassName & vbCrLf & _
               "RD " & LradI.Text & vbCrLf & _
               "TH " & lthck.Text & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 2" & vbCrLf & _
               "AIR" & vbCrLf & _
               "RD " & lRadM.Text & vbCrLf & _
               "TH " & Round(S * 25.4, 6) & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 3" & vbCrLf & _
               "RFH" & vbCrLf & _
               "RD " & CDbl(MRoC.Text) * -1 & vbCrLf & _
               "PK THM  -1 0.0" & vbCrLf & _
               "AP " & mSemiDiameter * 25.4 & vbCrLf
    Oslo_Out = Oslo_Out & _
               "AST" & vbCrLf & _
               "CC " & Mcc.Text & vbCrLf & _
               "NXT  // SRF 4" & vbCrLf & _
               "GLA " & GlassName & vbCrLf & _
               "PK CV   -2 0.0" & vbCrLf & _
               "PK THM  -3 0.0" & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 5" & vbCrLf & _
               "AIR" & vbCrLf & _
               "PK CV   -4 0.0" & vbCrLf & _
               "PK THM  -5 0.0" & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 6" & vbCrLf & _
               "AIR" & vbCrLf & _
               "CBK 1" & vbCrLf & _
               "WV " & WaveLength & " " & WaveLength & " " & WaveLength & " " & vbCrLf & _
               "WW 1.0 1.0 1.0" & vbCrLf & _
               "END  6" & vbCrLf & _
               "DLRS 3"
    
    Filehandle% = FreeFile
    Open (Oslo_Name) For Output As #Filehandle%
    Print #Filehandle%, Oslo_Out
    Close #Filehandle%
    
    Dim ttext As String
    
    If (check_file_ass(ttext)) Then
        If ttext <> "" And (vbYes = MsgBox("Launch Oslo File Now?", vbYesNo)) Then
            ShellExecute Me.hwnd, vbNullString, Oslo_Name, vbNullString, App.Path, 1
        End If
    End If
    
Else
    If Save_Oslo <> False Then MsgBox "Alas, you must visit the Refractive index menu above." & vbCrLf & "Oslo needs to know Glass Type used, not just refractive index, sorry.", vbOKOnly And vbCritical
    Save_Oslo = False
End If

If CHk_QtrWave.Value = 0 Then
    FindIt.Caption = "Find Null Variables"
    abrt.Visible = False
    Exit Sub
End If



'********** find + 1/4 wave OPD
 
Dim SPrime As Double
Dim SPlus As Double
Dim SMin As Double

SPrime = S


If Err_Iterate Then
    TempText = TextOut.Text & vbCrLf & vbCrLf & "*** Finding 1/" & Round((1 / ErrMargin), 2) & " wave OPD values for positive error in mirror - lens spacing " & vbCrLf & vbCrLf
Else
    TempText = TextOut.Text & vbCrLf & vbCrLf
End If
    Do
        
        Lo = lFL * 0.5
        If Err_Iterate Then
            S = S + 0.001
        Else
            S = S + (ErrMargin / 25.4)
        End If
        
        '{ Guess Y from simple geometry }
        Y = (mRadius + S) / mRadius * mSemiDiameter
        
        CalculateSA S, mSemiDiameter, Lo, Y, SA

        Pause_Display = Pause_Display + 1
        If Pause_Display > 10 Then
            TextOut.Text = TempText & "Object-Lens =" & Lo * 25.4 & " " & vbCrLf & _
                                      "Lens-Mirror = " & S * 25.4 & " " & vbCrLf & _
                                       "Marginal SA = " & SA * 25.4 & " " & vbCrLf
            Pause_Display = 0
        End If
        
        '{ Calculate a few output parameters }
        CalculateLi Y * 0.1, Lo, S, Li10, Y1, Y2    '{ To get Li10 }
        CalculateLi Y * 0.7, Lo, S, Li70, Y1, Y2    '{ To get Li70 }
        CalculateLi Y, Lo, S, Li100, Y1, Y2         '{ To get Y1 }
    
        Tol = 0.008 / 25.4 * ((Lo / (2 * Y)) ^ 2)

        OPD = Abs(Li70 - Li10)
        If OPD < Abs(Li100 - Li10) Then OPD = Abs(Li100 - Li10)
        
        If OPD < Abs(Li100 - Li70) Then OPD = Abs(Li100 - Li70)
        OPD = OPD / (4 * Tol)
        
        draw_Spin
        DoEvents
    Loop While Abs(OPD) <= ErrMargin And Not Kill_It And Err_Iterate
        
SPlus = Round((S - SPrime) * 25.4, 3)

TextOut.Text = TempText & _
    "Results for lens mirror spacing error of +" & SPlus & " mm" & vbCrLf & _
    "Object to Lens Distance         " & vbTab & vbTab & "=" & vbTab & Round(Lo * 25.4, 3) & " mm" & vbCrLf & _
    "Lens to Mirror Distance         " & vbTab & vbTab & "=" & vbTab & Round(S * 25.4, 3) & " mm" & vbCrLf & _
    "Working Diameter of Lens        " & vbTab & "=" & vbTab & Round((Y1 * 2) * 25.4, 3) & " mm" & vbCrLf & _
    "70% Zone Spherical Aberration   " & vbTab & "=" & vbTab & Round((Li70 - Li10) * 25.4, 3) & " mm" & vbCrLf & _
    "Marginal Spherical Aberration   " & vbTab & "=" & vbTab & Round((Li100 - Li10) * 25.4, 3) & " mm" & vbCrLf & _
    "Quarter-wave Tolerence          " & vbTab & "=" & vbTab & Round(Tol * 25.4, 3) & " mm" & vbCrLf & _
    "Maximum Optical Path Difference " & vbTab & "=" & vbTab & Round(OPD, 3) & " Waves"
    
If Save_Oslo And GlassName <> "" Then
    
    If Right(App.Path, 1) <> "\" Then
        Oslo_Name = App.Path & "\" & Round(MDiam.Text, 0) & " mm" & "_F-" & Round((MRoC.Text / MDiam.Text) / 2, 1) & "_created_" & Replace(Date, "/", "_", , , vbTextCompare) & "@" & Replace(Time, ":", "_", , , vbTextCompare) & ".len"
    Else
        Oslo_Name = App.Path & Round(MDiam.Text, 0) & " mm" & "_F-" & Round((MRoC.Text / MDiam.Text) / 2, 1) & "_created_" & Replace(Date, "/", "_", , , vbTextCompare) & "@" & Replace(Time, ":", "_", , , vbTextCompare) & ".len"
    End If
    Oslo_Out = "// OSLO 6.2 50002     0     0" & vbCrLf & _
               "LEN NEW " & Chr(34) & "Ross_Null_Positive_Error_Margin" & Chr(34) & " 0 6 " & vbCrLf & _
               "EBR  " & Round((Y1 * 25.4), 6) & vbCrLf & _
               "ANG  0.0000001" & vbCrLf & _
               "DES  " & Chr(34) & "OSLO" & Chr(34) & vbCrLf & _
               "UNI 1.0" & vbCrLf & _
               "// SRF 0" & vbCrLf & _
               "AIR" & vbCrLf & _
               "TH " & Round(Lo * 25.4, 9) & vbCrLf & _
               "AP 0.000248528801" & vbCrLf & _
               "NXT  // SRF 1" & vbCrLf & _
               "GLA " & GlassName & vbCrLf & _
               "RD " & LradI.Text & vbCrLf & _
               "TH " & lthck.Text & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 2" & vbCrLf & _
               "AIR" & vbCrLf & _
               "RD " & lRadM.Text & vbCrLf & _
               "TH " & Round(S * 25.4, 6) & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 3" & vbCrLf & _
               "RFH" & vbCrLf & _
               "RD " & CDbl(MRoC.Text) * -1 & vbCrLf & _
               "PK THM  -1 0.0" & vbCrLf & _
               "AP " & mSemiDiameter * 25.4 & vbCrLf
    Oslo_Out = Oslo_Out & _
               "AST" & vbCrLf & _
               "CC " & Mcc.Text & vbCrLf & _
               "NXT  // SRF 4" & vbCrLf & _
               "GLA " & GlassName & vbCrLf & _
               "PK CV   -2 0.0" & vbCrLf & _
               "PK THM  -3 0.0" & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 5" & vbCrLf & _
               "AIR" & vbCrLf & _
               "PK CV   -4 0.0" & vbCrLf & _
               "PK THM  -5 0.0" & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 6" & vbCrLf & _
               "AIR" & vbCrLf & _
               "CBK 1" & vbCrLf & _
               "WV " & WaveLength & " " & WaveLength & " " & WaveLength & " " & vbCrLf & _
               "WW 1.0 1.0 1.0" & vbCrLf & _
               "END  6" & vbCrLf & _
               "DLRS 3"
    
    Filehandle% = FreeFile
    Open (Oslo_Name) For Output As #Filehandle%
    Print #Filehandle%, Oslo_Out
    Close #Filehandle%
    
    If (check_file_ass(ttext)) Then
        If ttext <> "" And (vbYes = MsgBox("Launch Oslo File Now?", vbYesNo)) Then
            ShellExecute Me.hwnd, vbNullString, Oslo_Name, vbNullString, App.Path, 1
        End If
    End If
    
Else
    If Save_Oslo <> False Then MsgBox "Alas, you must visit the Refractive index menu above." & vbCrLf & "Oslo needs to know Glass Type used, not just refractive index, sorry.", vbOKOnly And vbCritical
    Save_Oslo = False
End If


'***************** finding negative error margin *******************
If Err_Iterate Then
    TempText = TextOut.Text & vbCrLf & vbCrLf & "*** Finding 1/" & Round((1 / ErrMargin), 2) & " wave OPD values for positive error in mirror - lens spacing " & vbCrLf & vbCrLf
Else
    TempText = TextOut.Text & vbCrLf & vbCrLf
End If
S = SPrime
    Do
        
        Lo = lFL * 0.5
        If Err_Iterate Then
            S = S - 0.001
        Else
            S = S - (ErrMargin / 25.4)
        End If
        '{ Guess Y from simple geometry }
        Y = (mRadius + S) / mRadius * mSemiDiameter
        
        CalculateSA S, mSemiDiameter, Lo, Y, SA

        Pause_Display = Pause_Display + 1
        If Pause_Display > 10 Then
            TextOut.Text = TempText & "Object-Lens =" & Lo * 25.4 & " " & vbCrLf & _
                                      "Lens-Mirror = " & S * 25.4 & " " & vbCrLf & _
                                       "Marginal SA = " & SA * 25.4 & " " & vbCrLf
            Pause_Display = 0
        End If
        '{ Calculate a few output parameters }
        CalculateLi Y * 0.1, Lo, S, Li10, Y1, Y2    '{ To get Li10 }
        CalculateLi Y * 0.7, Lo, S, Li70, Y1, Y2    '{ To get Li70 }
        CalculateLi Y, Lo, S, Li100, Y1, Y2         '{ To get Y1 }
    
        Tol = 0.008 / 25.4 * ((Lo / (2 * Y)) ^ 2)

        OPD = Abs(Li70 - Li10)
        If OPD < Abs(Li100 - Li10) Then OPD = Abs(Li100 - Li10)
        
        If OPD < Abs(Li100 - Li70) Then OPD = Abs(Li100 - Li70)
        OPD = OPD / (4 * Tol)
        
        draw_Spin
        DoEvents
    Loop While Abs(OPD) <= ErrMargin And Not Kill_It And Err_Iterate
        
SMin = Round((S - SPrime) * 25.4, 3)

TextOut.Text = TempText & _
    "Results for lens mirror spacing error of " & SMin & " mm" & vbCrLf & _
    "Object to Lens Distance         " & vbTab & vbTab & "=" & vbTab & Round(Lo * 25.4, 3) & " mm" & vbCrLf & _
    "Lens to Mirror Distance         " & vbTab & vbTab & "=" & vbTab & Round(S * 25.4, 3) & " mm" & vbCrLf & _
    "Working Diameter of Lens        " & vbTab & "=" & vbTab & Round((Y1 * 2) * 25.4, 3) & " mm" & vbCrLf & _
    "70% Zone Spherical Aberration   " & vbTab & "=" & vbTab & Round((Li70 - Li10) * 25.4, 3) & " mm" & vbCrLf & _
    "Marginal Spherical Aberration   " & vbTab & "=" & vbTab & Round((Li100 - Li10) * 25.4, 3) & " mm" & vbCrLf & _
    "Quarter-wave Tolerence          " & vbTab & "=" & vbTab & Round(Tol * 25.4, 3) & " mm" & vbCrLf & _
    "Maximum Optical Path Difference " & vbTab & "=" & vbTab & Round(OPD, 3) & " Waves"

If Save_Oslo And GlassName <> "" Then
    
    If Right(App.Path, 1) <> "\" Then
        Oslo_Name = App.Path & "\" & Round(MDiam.Text, 0) & " mm" & "_F-" & Round((MRoC.Text / MDiam.Text) / 2, 1) & "_created_" & Replace(Date, "/", "_", , , vbTextCompare) & "@" & Replace(Time, ":", "_", , , vbTextCompare) & ".len"
    Else
        Oslo_Name = App.Path & Round(MDiam.Text, 0) & " mm" & "_F-" & Round((MRoC.Text / MDiam.Text) / 2, 1) & "_created_" & Replace(Date, "/", "_", , , vbTextCompare) & "@" & Replace(Time, ":", "_", , , vbTextCompare) & ".len"
    End If
    Oslo_Out = "// OSLO 6.2 50002     0     0" & vbCrLf & _
               "LEN NEW " & Chr(34) & "Ross_Null_Negative_Error_Margin" & Chr(34) & " 0 6 " & vbCrLf & _
               "EBR  " & Round((Y1 * 25.4), 6) & vbCrLf & _
               "ANG  0.0000001" & vbCrLf & _
               "DES  " & Chr(34) & "OSLO" & Chr(34) & vbCrLf & _
               "UNI 1.0" & vbCrLf & _
               "// SRF 0" & vbCrLf & _
               "AIR" & vbCrLf & _
               "TH " & Round(Lo * 25.4, 9) & vbCrLf & _
               "AP 0.000248528801" & vbCrLf & _
               "NXT  // SRF 1" & vbCrLf & _
               "GLA " & GlassName & vbCrLf & _
               "RD " & LradI.Text & vbCrLf & _
               "TH " & lthck.Text & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 2" & vbCrLf & _
               "AIR" & vbCrLf & _
               "RD " & lRadM.Text & vbCrLf & _
               "TH " & Round(S * 25.4, 6) & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 3" & vbCrLf & _
               "RFH" & vbCrLf & _
               "RD " & CDbl(MRoC.Text) * -1 & vbCrLf & _
               "PK THM  -1 0.0" & vbCrLf & _
               "AP " & mSemiDiameter * 25.4 & vbCrLf
    Oslo_Out = Oslo_Out & _
               "AST" & vbCrLf & _
               "CC " & Mcc.Text & vbCrLf & _
               "NXT  // SRF 4" & vbCrLf & _
               "GLA " & GlassName & vbCrLf & _
               "PK CV   -2 0.0" & vbCrLf & _
               "PK THM  -3 0.0" & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 5" & vbCrLf & _
               "AIR" & vbCrLf & _
               "PK CV   -4 0.0" & vbCrLf & _
               "PK THM  -5 0.0" & vbCrLf & _
               "AP " & LDiam.Text / 2 & vbCrLf & _
               "NXT  // SRF 6" & vbCrLf & _
               "AIR" & vbCrLf & _
               "CBK 1" & vbCrLf & _
               "WV " & WaveLength & " " & WaveLength & " " & WaveLength & " " & vbCrLf & _
               "WW 1.0 1.0 1.0" & vbCrLf & _
               "END  6" & vbCrLf & _
               "DLRS 3"
    
    Filehandle% = FreeFile
    Open (Oslo_Name) For Output As #Filehandle%
    Print #Filehandle%, Oslo_Out
    Close #Filehandle%

    If (check_file_ass(ttext)) Then
        If ttext <> "" And (vbYes = MsgBox("Launch Oslo File Now?", vbYesNo)) Then
            ShellExecute Me.hwnd, vbNullString, Oslo_Name, vbNullString, App.Path, 1
        End If
    End If
    
Else
    If Save_Oslo <> False Then MsgBox "Alas, you must visit the Refractive index menu above." & vbCrLf & "Oslo needs to know Glass Type used, not just refractive index, sorry.", vbOKOnly And vbCritical
    Save_Oslo = False
End If


FindIt.Caption = "Find Null Variables"
abrt.Visible = False

Exit Sub



NumbersPls:
    MsgBox "Please check your data entries, seems there is a problem reading one of your entries as a Numerical Value" & vbCrLf & _
                "**OR**" & vbCrLf & _
                "The program converged to an infinity (IE division by zero)", vbOKOnly And vbCritical, "Hmmm, how did that happen?"
    Debug.Print Err.Description
    Err.Clear
End Sub

Private Sub draw_Spin()
Dim spintxt(3) As String
spintxt(0) = "|"
spintxt(1) = "/"
spintxt(2) = "--"
spintxt(3) = "\"

Static Cur_Spin As Long
Static Spin_Delay As Long

Spin_Delay = Spin_Delay + 1
    
If Spin_Delay > 1000 Then
    Cur_Spin = Cur_Spin + 1
    If Cur_Spin > 3 Then Cur_Spin = 0
    FindIt.Caption = "Processing " & spintxt(Cur_Spin)
    Spin_Delay = 0
End If



End Sub


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
Kill_It = True
End Sub

Private Sub Form_Load()
TextOut.Text = "Ross Null Test Setup Calculations Version " & App.Major & "." & App.Minor & "." & App.Revision & vbCrLf & _
            "Original Copyright (c) 1990, Doug George" & vbCrLf & _
            "25 Conover Street,Ottawa, Ontario, Canada, K2G 4C3" & vbCrLf & _
            "Copyright (c) 2005, James C Lerch" & vbCrLf & _
            "8212 25th Street East, Parrish, Forida, 34219, USA" & vbCrLf & _
            "Special Thanks to:" & vbCrLf & _
            vbTab & "Dave Rowe for his glass type and refractive index code" & vbCrLf & _
            vbTab & "Peter Ceravolo for providing a reliable source of Ross Null Lenses" & vbCrLf & _
            vbTab & "http://www.ceravolo.com" & vbCrLf & _
            "This shareware program may be freely distributed and used" & vbCrLf & _
            vbCrLf & _
            "Enter Mirror and Ross Null Lens data above and press the 'Find Null Variables' buton" & vbCrLf & _
            vbCrLf & _
            "For Ross Null Surface radii,with light source on the left of null lens,  and Mirror on Right of the null lens:" & vbCrLf & _
            vbCrLf & _
            "A) Light source side of null lens will have Positive value for Convex surface, Negative value for Concave Surface" & vbCrLf & _
            "B) Mirror side of null lens will have Negative value for Convex surface, Positive value for Concave Surface." & vbCrLf & _
            "C) For a flat surface use 9e99 for the radius" & vbCrLf & _
            vbCrLf & _
            "******** NOTE ********" & vbCrLf & _
            "Default Ross Null Data is for Peter Ceravolo's Ross Null Lens when testing at a wave length of 632.8nm (HeNe)" & vbCrLf & _
            vbCrLf & _
            "** If you are going to test at some other wavelength, update the refractive index data to get reliable results" & vbCrLf & _
            vbTab & "(Click refractive index, and change wave length to that used in your test enviroment)"


'Setup starting variables for wavelength and Material Type
WaveLength = 0.6328
GlassName = "BK7"

End Sub

Private Sub Form_Resize()
TextOut.Height = FormMain.Height - 2600
End Sub

Private Sub inches_Click(Index As Integer)

'Converts units back and forth


Static Last_Index As Integer
Static Init_1st_Time As Boolean 'Solve for fact we now start with mm as default..

If Init_1st_Time = False Then
    Last_Index = 1
    Init_1st_Time = True
End If
    

If Last_Index = Index Then Exit Sub     'No Change in units

If Last_Index = 0 Then                  'Changing from English to Metric
    MDiam.Text = MDiam.Text * 25.4
    MRoC.Text = MRoC.Text * 25.4
    LradI.Text = LradI.Text * 25.4
    lRadM.Text = lRadM.Text * 25.4
    lthck.Text = lthck.Text * 25.4
    LDiam.Text = LDiam.Text * 25.4
Else
                                        'Must be going from Metric to English
    MDiam.Text = MDiam.Text / 25.4
    MRoC.Text = MRoC.Text / 25.4
    LradI.Text = LradI.Text / 25.4
    lRadM.Text = lRadM.Text / 25.4
    lthck.Text = lthck.Text / 25.4
    LDiam.Text = LDiam.Text / 25.4
End If
    
Last_Index = Index

End Sub


