VERSION 5.00
Begin VB.Form Err_Explore 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Null lens to mirror spacing error"
   ClientHeight    =   2535
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   6030
   Icon            =   "Err_Explore.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2535
   ScaleWidth      =   6030
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.Frame Err_Margin 
      Caption         =   "How much error do you want to explore for?"
      Height          =   2295
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   4455
      Begin VB.TextBox Spec_Error 
         Height          =   285
         Left            =   2640
         TabIndex        =   8
         Text            =   "0.1"
         Top             =   1800
         Width           =   1095
      End
      Begin VB.OptionButton Err_Amount 
         Caption         =   "+/- Only this amount of null lens - mirror spacing error ->"
         Height          =   495
         Index           =   4
         Left            =   240
         TabIndex        =   7
         Top             =   1680
         Width           =   2415
      End
      Begin VB.OptionButton Err_Amount 
         Caption         =   "+/- 0.05 wave Optical Path Distance (OPD) error"
         Height          =   375
         Index           =   3
         Left            =   240
         TabIndex        =   6
         Top             =   1320
         Width           =   3855
      End
      Begin VB.OptionButton Err_Amount 
         Caption         =   "+/- 0.1 wave Optical Path Distance (OPD) error"
         Height          =   375
         Index           =   2
         Left            =   240
         TabIndex        =   5
         Top             =   960
         Width           =   3855
      End
      Begin VB.OptionButton Err_Amount 
         Caption         =   "+/- 0.125 wave Optical Path Distance (OPD) error"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   4
         Top             =   720
         Width           =   3855
      End
      Begin VB.OptionButton Err_Amount 
         Caption         =   "+/- 0.25 wave Optical Path Distance (OPD) error"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   3
         Top             =   360
         Width           =   3855
      End
      Begin VB.Label lblunit 
         Caption         =   "Label1"
         Height          =   255
         Left            =   3840
         TabIndex        =   9
         Top             =   1800
         Width           =   495
      End
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4680
      TabIndex        =   1
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   4680
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "Err_Explore"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Dim Curr_selected As Integer

Private Sub Err_Amount_Click(Index As Integer)

'This sub will setup variables for exploring the amount of
'Lens to mirror spacing as a result of user measurment error
'During setup, off course all users will perfectly space and
'collimate their optics :)

Select Case Index
    Case Is = 0
        ErrMargin = 0.25
        Err_Iterate = True
        Curr_selected = Index
    Case Is = 1
        ErrMargin = 0.125
        Err_Iterate = True
        Curr_selected = Index
    Case Is = 2
        ErrMargin = 0.1
        Err_Iterate = True
        Curr_selected = Index
    Case Is = 3
        ErrMargin = 0.05
        Err_Iterate = True
        Curr_selected = Index
    Case Is = 4
            ErrMargin = CDbl(Spec_Error.Text) 'will pass this variable to main code to solve for direct entry
            Err_Iterate = False 'Set this so code won't loop around looking for a specific OPD, and instead implements user entry
            Curr_selected = Index
    Case Else
        Err_Iterate = False
End Select

End Sub

Private Sub Form_Load()
Static first_time As Boolean


If first_time = False Then
    Curr_selected = 1
    first_time = True
End If

If Curr_selected = 4 And ErrMargin <> 0 Then Spec_Error.Text = ErrMargin
Err_Amount(Curr_selected).Value = True


If FormMain.inches(0).Value = True Then 'units in inches, add Inch sign to unit entry label
    lblunit.Caption = Chr(34)
Else
    lblunit.Caption = "mm"
End If

End Sub



Private Sub OKButton_Click()
If Err_Iterate = False And ErrMargin = 0 Then FormMain.CHk_QtrWave.Value = 0
Unload Me  'User selection complete
End Sub

Private Sub CancelButton_Click()
'User selected cancel, so let's uncheck the error margin checkbox on formmain
FormMain.CHk_QtrWave.Value = 0
Unload Me
End Sub


Private Sub Spec_Error_GotFocus()
Err_Amount(4).Value = True
End Sub

Private Sub Spec_Error_LostFocus()
If IsNumeric(Spec_Error.Text) = False Then
    MsgBox "Error margin data is not a numerical value!"
    Spec_Error.SetFocus
Else
    Err_Amount_Click (4)
End If
    
End Sub
