VERSION 5.00
Begin VB.Form RiN 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Calculate Refractive Index from Glass Catalog"
   ClientHeight    =   3450
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   5715
   Icon            =   "RiN.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3450
   ScaleWidth      =   5715
   StartUpPosition =   1  'CenterOwner
   Begin VB.Frame Frame4 
      Caption         =   "Glass Data"
      Height          =   615
      Left            =   0
      TabIndex        =   14
      Top             =   1080
      Width           =   4335
      Begin VB.Label lbl_Glass_Data 
         Caption         =   "Glass_Data"
         Height          =   255
         Left            =   240
         TabIndex        =   15
         Top             =   240
         Width           =   3855
      End
   End
   Begin VB.ComboBox Sort_Glass 
      Height          =   315
      Left            =   4440
      Sorted          =   -1  'True
      TabIndex        =   13
      Text            =   "Combo1"
      Top             =   960
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.Frame Frame3 
      Caption         =   "Results"
      Height          =   975
      Left            =   0
      TabIndex        =   10
      Top             =   2400
      Width           =   4335
      Begin VB.Label lbl_RiN 
         Caption         =   "Effective Index of Refraction"
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   600
         Width           =   3975
      End
      Begin VB.Label lbl_Glass 
         Caption         =   "Glass Type N/A"
         Height          =   255
         Left            =   240
         TabIndex        =   11
         Top             =   240
         Width           =   3975
      End
   End
   Begin VB.Frame Frame2 
      Height          =   735
      Left            =   0
      TabIndex        =   7
      Top             =   1680
      Width           =   4335
      Begin VB.TextBox txt_Wave 
         Height          =   285
         Left            =   3000
         TabIndex        =   9
         Text            =   "632.8"
         Top             =   240
         Width           =   1215
      End
      Begin VB.Label Label1 
         Alignment       =   2  'Center
         Caption         =   "Test Wave Length (nm)  {press enter to update}"
         Height          =   375
         Left            =   240
         TabIndex        =   8
         Top             =   240
         Width           =   2655
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Glass Type"
      Height          =   1095
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   4335
      Begin VB.ComboBox Ohara_List 
         Height          =   315
         Left            =   1080
         TabIndex        =   6
         Text            =   "Ohara Catalog"
         Top             =   720
         Width           =   3135
      End
      Begin VB.ComboBox Schott_List 
         Height          =   315
         Left            =   1080
         TabIndex        =   5
         Text            =   "Schott Catalog"
         Top             =   360
         Width           =   3135
      End
      Begin VB.OptionButton Catalog 
         Caption         =   "Ohara"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   4
         Top             =   720
         Width           =   855
      End
      Begin VB.OptionButton Catalog 
         Caption         =   "Schott"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   3
         Top             =   360
         Width           =   855
      End
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4440
      TabIndex        =   1
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   4440
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label lbl_warn 
      Alignment       =   2  'Center
      BackColor       =   &H000000C0&
      Caption         =   "This Glass is not in the OSLO glass      database.    If you select this glass, your OSLO Lens file will not work properly"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2175
      Left            =   4440
      TabIndex        =   16
      Top             =   1200
      Visible         =   0   'False
      Width           =   1215
   End
End
Attribute VB_Name = "RiN"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Dim EffectiveRin As String
Dim startGlass As String
Dim startW As Double
Dim LastCat As Long
Dim LastGlass(1) As Long
Dim UnloadByX As Boolean 'if they hit the X button to unload form, Gotta handle stuff like a cance action.

Private Sub Form_Load()
Static first_time As Boolean  'first time user visited here, setup default entries.
If first_time = False Then    'from now on we'll use values that user had previously
    LastGlass(0) = 99999      'selected
    first_time = True
End If


startGlass = GlassName
startW = WaveLength

If WaveLength <> 0 Then txt_Wave = WaveLength * 1000
InitGlass
Catalog(LastCat).Value = True
Label1.Caption = "Test Wave Legth (nm)" & vbCrLf & "{Press enter key to update}"
DoEvents

UnloadByX = True

End Sub

Private Sub Catalog_Click(Index As Integer)
If Index = 0 Then 'Schott catalog selected
    Schott_List.Enabled = True
    Ohara_List.Enabled = False
    If LastGlass(0) = 99999 Then
        Schott_List.ListIndex = 49 'select default as BK7
    Else
        Schott_List.ListIndex = LastGlass(0)
    End If
    Schott_List_Click
Else
    Ohara_List.Enabled = True
    Schott_List.Enabled = False
    Ohara_List.ListIndex = LastGlass(1) 'who knows what ohara to select
    Ohara_List_Click
End If

End Sub
Private Sub Schott_List_Click()
'Update Glass Data, and calc effective index
Dim nd As Double, nc As Double, nf As Double, v As Double, w As Double
Dim name As String, nds As String, vs As String
    
GlassNum = RiN.Schott_List.ListIndex
    
If (GlassNum >= 0) Then
    GlassSelected = sg(GlassNum)
    
    name = GlassSelected.N
    nd = GetIndex(GlassSelected, 587.56)
    nc = GetIndex(GlassSelected, 656.3)
    nf = GetIndex(GlassSelected, 486.1)
    
    v = (nd - 1) / (nf - nc)
    lbl_Glass_Data = "Schott " & name & "   Nd=" & Round(nd, 4) & "   V=" & Round(v, 3)
    If Right(name, 1) = "*" Then lbl_warn.Visible = True Else lbl_warn.Visible = False
    If IsNumeric(txt_Wave) Then
        w = CDbl(txt_Wave)
        If w < 350 Or w > 850 Then
            MsgBox "Wavelength needs to be between 350 to 850nm", vbOKOnly And vbCritical
            txt_Wave.SetFocus
        Else
            lbl_Glass.Caption = "Glass Type = Schott " & name & " at " & w & "nm"
            EffectiveRin = Round(GetIndex(GlassSelected, w), 5)
            lbl_RiN.Caption = "Effective Index of Refraction = " & EffectiveRin
            GlassName = name
            WaveLength = w * 0.001
        End If
    Else
        MsgBox "wave length data must be a numeric value!", vbOKOnly
        txt_Wave.SetFocus

    End If
        
End If
LastCat = 0
End Sub

Private Sub Ohara_List_Click()
'Update Glass Data, and calc effective index

Dim nd As Double, nc As Double, nf As Double, v As Double, w As Double
Dim name As String, nds As String, vs As String
    
GlassNum = RiN.Ohara_List.ListIndex
    
If (GlassNum >= 0) Then
    GlassSelected = og(GlassNum)
    
    name = GlassSelected.N
    nd = GetIndex(GlassSelected, 587.56)
    nc = GetIndex(GlassSelected, 656.3)
    nf = GetIndex(GlassSelected, 486.1)
    
    v = (nd - 1) / (nf - nc)
    lbl_Glass_Data = "Ohara " & name & "   Nd=" & Round(nd, 4) & "   V=" & Round(v, 3)
    
    If Left(name, 2) = "O_" Then lbl_warn.Visible = False Else lbl_warn.Visible = True
    
    If IsNumeric(txt_Wave) Then
        w = CDbl(txt_Wave)
        If w < 350 Or w > 850 Then
            MsgBox "Wavelength needs to be between 350 to 850nm", vbOKOnly And vbCritical
            txt_Wave.SetFocus
        Else
            lbl_Glass.Caption = "Glass Type = Ohara " & name & " at " & w & "nm"
            EffectiveRin = Round(GetIndex(GlassSelected, w), 5)
            lbl_RiN.Caption = "Effective Index of Refraction = " & EffectiveRin
            GlassName = name
            WaveLength = w * 0.001
        End If
    Else
        MsgBox "wave length data must be a numeric value!", vbOKOnly
        txt_Wave.SetFocus
    End If

End If
LastCat = 1
End Sub


Private Sub txt_Wave_KeyDown(KeyCode As Integer, Shift As Integer)
'User selected radio button for glass type, so figure it out and send code on its way.
If KeyCode = 13 Then
    If Catalog(0).Value = True Then 'schott update
        Schott_List_Click
    Else
        Ohara_List_Click
    End If
End If
End Sub

Private Sub txt_Wave_LostFocus()
    If Catalog(0).Value = True Then 'schott update
        Schott_List_Click
    Else
        Ohara_List_Click
    End If
End Sub


Private Sub OKButton_Click()
'Move effective refractive index back to main form index entry.
If Catalog(0).Value = True Then 'schott update
    Schott_List_Click
Else
    Ohara_List_Click
End If
FormMain.LindexR.Text = EffectiveRin
UnloadByX = False
Unload Me
End Sub


Private Sub CancelButton_Click()

'If user cancels from RiN Calc screen, push back Glassname and W (they change in sub calls above)
If (GlassName <> startGlass) Then
    If startGlass = "" Then
        GlassName = ""
    Else
        GlassName = startGlass
    End If
    If (WaveLength <> startW) Then WaveLength = startW
End If
UnloadByX = False
Unload Me
End Sub

Private Sub Form_Unload(Cancel As Integer)
If UnloadByX Then CancelButton_Click 'Do this if user selected "X" to unload form..
LastGlass(0) = Schott_List.ListIndex
LastGlass(1) = Ohara_List.ListIndex

End Sub
